<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateDeviceMobilityReq StructType
 * @subpackage Structs
 */
class UpdateDeviceMobilityReq extends NameAndGUIDRequest
{
    /**
     * The newName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $newName;
    /**
     * The subNet
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $subNet;
    /**
     * The subNetMaskSz
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $subNetMaskSz;
    /**
     * The removeMembers
     * Meta information extracted from the WSDL
     * - choice: removeMembers | addMembers | members
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\RemoveMembers
     */
    public $removeMembers;
    /**
     * The addMembers
     * Meta information extracted from the WSDL
     * - choice: removeMembers | addMembers | members
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\AddMembers
     */
    public $addMembers;
    /**
     * The members
     * Meta information extracted from the WSDL
     * - choice: removeMembers | addMembers | members
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\Members
     */
    public $members;
    /**
     * Constructor method for UpdateDeviceMobilityReq
     * @uses UpdateDeviceMobilityReq::setNewName()
     * @uses UpdateDeviceMobilityReq::setSubNet()
     * @uses UpdateDeviceMobilityReq::setSubNetMaskSz()
     * @uses UpdateDeviceMobilityReq::setRemoveMembers()
     * @uses UpdateDeviceMobilityReq::setAddMembers()
     * @uses UpdateDeviceMobilityReq::setMembers()
     * @param string $newName
     * @param string $subNet
     * @param string $subNetMaskSz
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\RemoveMembers $removeMembers
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\AddMembers $addMembers
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\Members $members
     */
    public function __construct($newName = null, $subNet = null, $subNetMaskSz = null, \\Losc\CucmBundle\Model\Webservice\StructType\RemoveMembers $removeMembers = null, \\Losc\CucmBundle\Model\Webservice\StructType\AddMembers $addMembers = null, \\Losc\CucmBundle\Model\Webservice\StructType\Members $members = null)
    {
        $this
            ->setNewName($newName)
            ->setSubNet($subNet)
            ->setSubNetMaskSz($subNetMaskSz)
            ->setRemoveMembers($removeMembers)
            ->setAddMembers($addMembers)
            ->setMembers($members);
    }
    /**
     * Get newName value
     * @return string|null
     */
    public function getNewName()
    {
        return $this->newName;
    }
    /**
     * Set newName value
     * @param string $newName
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateDeviceMobilityReq
     */
    public function setNewName($newName = null)
    {
        $this->newName = $newName;
        return $this;
    }
    /**
     * Get subNet value
     * @return string|null
     */
    public function getSubNet()
    {
        return $this->subNet;
    }
    /**
     * Set subNet value
     * @param string $subNet
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateDeviceMobilityReq
     */
    public function setSubNet($subNet = null)
    {
        $this->subNet = $subNet;
        return $this;
    }
    /**
     * Get subNetMaskSz value
     * @return string|null
     */
    public function getSubNetMaskSz()
    {
        return $this->subNetMaskSz;
    }
    /**
     * Set subNetMaskSz value
     * @param string $subNetMaskSz
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateDeviceMobilityReq
     */
    public function setSubNetMaskSz($subNetMaskSz = null)
    {
        $this->subNetMaskSz = $subNetMaskSz;
        return $this;
    }
    /**
     * Get removeMembers value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RemoveMembers|null
     */
    public function getRemoveMembers()
    {
        return isset($this->removeMembers) ? $this->removeMembers : null;
    }
    /**
     * Set removeMembers value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\RemoveMembers $removeMembers
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateDeviceMobilityReq
     */
    public function setRemoveMembers(\\Losc\CucmBundle\Model\Webservice\StructType\RemoveMembers $removeMembers = null)
    {
        if (is_null($removeMembers) || (is_array($removeMembers) && empty($removeMembers))) {
            unset($this->removeMembers);
        } else {
            $this->removeMembers = $removeMembers;
        }
        return $this;
    }
    /**
     * Get addMembers value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\AddMembers|null
     */
    public function getAddMembers()
    {
        return isset($this->addMembers) ? $this->addMembers : null;
    }
    /**
     * Set addMembers value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\AddMembers $addMembers
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateDeviceMobilityReq
     */
    public function setAddMembers(\\Losc\CucmBundle\Model\Webservice\StructType\AddMembers $addMembers = null)
    {
        if (is_null($addMembers) || (is_array($addMembers) && empty($addMembers))) {
            unset($this->addMembers);
        } else {
            $this->addMembers = $addMembers;
        }
        return $this;
    }
    /**
     * Get members value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\Members|null
     */
    public function getMembers()
    {
        return isset($this->members) ? $this->members : null;
    }
    /**
     * Set members value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\Members $members
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateDeviceMobilityReq
     */
    public function setMembers(\\Losc\CucmBundle\Model\Webservice\StructType\Members $members = null)
    {
        if (is_null($members) || (is_array($members) && empty($members))) {
            unset($this->members);
        } else {
            $this->members = $members;
        }
        return $this;
    }
}
